<template>
    <div id="title-form">
        <hr class="my-3">
        <form @submit.prevent="handleSubmit">
            <h4 class="font-weight-normal">Title</h4>
            <!--title-->
            <div class="form-group">
                <label for="name">Name</label>
                <input v-model="title.name" @change="resetErrors" type="text" class="form-control" id="name"
                       autocomplete="off" placeholder="Write here" required
                >
                <small class="text-muted">Required</small>
            </div>
            <div class="form-group">
                <div class="row">
                    <!--released-->
                    <div class="col">
                        <label for="released">Released</label>
                        <input v-model="title.released" @focus="resetErrors" type="number" class="form-control"
                               id="released" autocomplete="off" min="1900" max="2099" placeholder="Enter a year"
                               required
                        >
                        <small class="text-muted">Required</small>
                    </div>
                    <!--ended-->
                    <div class="col">
                        <label for="ended">Ended</label>
                        <input v-model="title.ended" @focus="resetErrors" type="number" class="form-control" id="ended"
                               autocomplete="off" min="1900" max="2099" placeholder="Enter a year"
                        >
                        <small class="text-muted">Optional</small>
                    </div>
                </div>
            </div>
            <div class="form-group">
                <div class="row">
                    <!--budget-->
                    <div class="col">
                        <label for="budget">Budget</label>
                        <div class="input-group">
                            <div class="input-group-prepend">
                                <span class="input-group-text"><span class="fas fa-dollar-sign"/></span>
                            </div>
                            <input v-model="title.budget" @focus="resetErrors" type="number" class="form-control"
                                   id="budget" autocomplete="off" min="0" max="500000000" placeholder="Enter a number"
                            >
                        </div>
                        <small class="text-muted">Optional</small>
                    </div>
                    <!--gross-->
                    <div class="col">
                        <label for="gross">Gross</label>
                        <div class="input-group">
                            <div class="input-group-prepend">
                                <span class="input-group-text"><span class="fas fa-dollar-sign"/></span>
                            </div>
                            <input v-model="title.gross" @focus="resetErrors" type="number" class="form-control"
                                   id="gross" autocomplete="off" min="0" max="5000000000" placeholder="Enter a number"
                            >
                        </div>
                        <small class="text-muted">Optional</small>
                    </div>
                </div>
            </div>
            <!--type-->
            <div class="form-group">
                <label>Type</label>
                <selected v-if="type" @reselect:option="loseType(true)" table="types" :selected="type"/>
                <custom-select v-else @select:option="saveType" table="types"/>
                <small v-if="!type" class="text-muted">Required</small>
            </div>
            <div class="form-group">
                <label>Genres</label>
                <p v-if="genres.length > 0">
                    <!--<small class="mr-3">Selected genres:</small>-->
                    <span v-for="(genre, index) in genres" :key="index" @click="removeGenre(index)"
                          class="badge badge-pill badge-dark mr-2">
                        {{ genre.name }} <span class="fas fa-times"/>
                    </span>
                </p>
                <custom-select @select:option="addGenre" table="genres"/>
                <small class="text-muted">Optional</small>
            </div>
            <button class="btn btn-primary">
                <span class="fas fa-plus"/> Insert
            </button>
            <p v-if="errors.success" class="bg-success text-white mt-4 px-2">Title inserted</p>
            <p v-else-if="errors.fail" class="bg-danger text-white mt-4 px-2">Something went wrong</p>
            <p v-else-if="errors.invalid" class="bg-danger text-white mt-4 px-2">Required input missing</p>
        </form>
    </div>
</template>

<script>
    import Selected from "@/components/Selected";
    import CustomSelect from "@/components/CustomSelect";

    export default {
        name: "title-form",
        components: {
            CustomSelect,
            Selected
        },
        data() {
            return {
                type: null,
                title: {
                    name: '',
                    released: '',
                    ended: '',
                    budget: '',
                    gross: '',
                    type_id: null,
                },
                genres: [],
                errors: {
                    success: false,
                    fail: false,
                    invalid: false,
                },
            }
        },
        computed: {
            typeIsValid() {
                return this.title.type_id !== null;
            }
        },
        methods: {
            async handleSubmit() {
                try {
                    this.title.name = this.title.name.trim();
                    if (!this.title.name || !this.typeIsValid || !this.title.released.trim()) {
                        this.errors.invalid = true;
                        return;
                    }
                    if (!this.title.ended.trim()) {
                        this.title.ended = null;
                    }
                    if (!this.title.budget.trim()) {
                        this.title.budget = null;
                    }
                    if (!this.title.gross.trim()) {
                        this.title.gross = null;
                    }
                    let response, data;
                    response = await fetch(`http://localhost:8081/api/entertainment`, {
                        method: 'POST',
                        body: JSON.stringify(this.title),
                        headers: {'Content-type': 'application/json; charset=UTF-8'},
                    });
                    this.errors.success = await response.json();
                    if (!this.errors.success) {
                        this.errors.fail = true
                    } else {
                        response = await fetch(`http://localhost:8081/api/entertainment?order=e.id%20desc`);
                        data = await response.json();
                        const title = data[0];
                        const entry = {
                            title_id: title.id
                        };
                        for (let genre of this.genres) {
                            entry.genre_id = genre.id;
                            response = await fetch(`http://localhost:8081/api/related_genres`, {
                                method: 'POST',
                                body: JSON.stringify(entry),
                                headers: {'Content-type': 'application/json; charset=UTF-8'},
                            });
                            data = await response.json();
                            this.errors.success = this.errors.success && data;
                            if (!this.errors.success) {
                                this.errors.fail = true;
                                return;
                            }
                        }
                        this.resetInput();
                    }
                } catch (e) {
                    console.error(e);
                    this.errors.fail = true;
                }
            },
            saveType(type) {
                this.resetErrors();
                this.type = type;
                this.title.type_id = type.id;
            },
            addGenre(genre) {
                this.genres.push(genre);
            },
            removeGenre(index) {
                this.genres.splice(index, 1);
            },
            async loseType(reset) {
                this.type = null;
                this.title.type_id = null;
                if (reset) {
                    this.resetErrors();
                    await this.$forceUpdate();
                    document.getElementById('custom-select-types-button').focus();
                }
            },
            resetErrors() {
                this.errors.fail = false;
                this.errors.success = false;
                this.errors.invalid = false;
            },
            resetInput() {
                this.loseType(false);
                this.title.name = '';
                this.title.released = '';
                this.title.ended = '';
                this.title.budget = '';
                this.title.gross = '';
                this.genres = [];
                document.getElementById('name').focus();
            },
        }
    }
</script>

<style scoped>
    span.badge-pill {
        cursor: pointer;
    }
</style>